from typing import Any

from django.views.generic.base import TemplateView


class TestView(TemplateView):
    template_name = 'test.html'

    def get_context_data(self, **kwargs) -> dict[str, Any]:
        context = super().get_context_data(**kwargs)
        if 'test' not in self.request.session:
            self.request.session['test'] = 'testdata'
        context['user'] = self.request.user
        return context
